//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "comm.h"
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>

#include <fstream>

#define NB_DISPLAYS 1
#define NB_NUMBERS 8
#define MAX_PIX 50*50

  struct TImagePacket {
    bool DisplayID;
    unsigned char Type;
    unsigned int PixNum;
    unsigned int Height;
    unsigned int Width;
    byte Pix[2*MAX_PIX];
    TImage *Display;
    TTrackBar *Scaling;
    TEdit *EdScaling;
    TEdit* Label;
  };

  struct TNumberPacket {
    bool ReadFlag;  // true if the number is read from the robot
    bool Signed;
    unsigned char Value;
    TTrackBar *TB;
    TEdit *Ed;
    TEdit* Label;
  };

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TButton *Connect;
  TImage *Display0;
  TTrackBar *TB0;
  TEdit *Ed0;
  TLabel *Label5;
  TButton *Pause;
  TEdit *Edit1;

        TEdit *PortEdt;
        TLabel *Label26;
        TEdit *Edit2;
        TEdit *Edit3;
        TLabel *Label1;
        TLabel *Label2;
        TCheckBox *CheckBox1;
  void __fastcall ConnectClick(TObject *Sender);
  void __fastcall TBChange(TObject *Sender);
  void __fastcall EdChange(TObject *Sender);
  void __fastcall PauseClick(TObject *Sender);


       // void __fastcall Label5Click(TObject *Sender);
      //  void __fastcall Edit1Change(TObject *Sender);

private:	// User declarations
  bool StopWaitingForCommands;

  TCommPort *CommPort;
  unsigned char TxBuffer[3000];
  unsigned char RxBuffer[3000];

  signed short Encoders[2];
  signed char MotorCommands[2];

  TImagePacket ImagePacket[NB_DISPLAYS];

  TNumberPacket NumberPacket[NB_NUMBERS];

public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);
  __fastcall virtual ~TMainForm();
  void __fastcall WaitForCommands(void);
  void __fastcall ProcessCommand(void);
  void __fastcall DisplayImage(unsigned int ID);
  void __fastcall RotateImage(unsigned int ID);
  void __fastcall DisplayNumber(unsigned char ID);

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
